<?php include "../global/header.html"; ?>
    
<!-- Summary begins here -->

<table bgcolor="#FFFFFF" width="80%" align="center" cellpadding="20">
    <tr>
        <td>
            <H3>Title:  Dropshadow module</H3>
            <p>Author: Pete Shinners<br>
            Submission date: December 03, 2001</p>
	  
            <p>Description: A function to render text with a user-defined drop shadow.</p>
            
            <p align="center"><img src="dropshadow.gif" width="695" height="59"></p>

            <p>Download: <a href="dropshadow.py">dropshadow.py</a></p>	  

            <p>pygame version required: Any<br>
            SDL version required: Any<br>
            Python version required: Any</p>

            <p>Comments: The &quot;offset&quot; argument that the function takes is the number of pixels the shadow will appear, below and to the right of the original text.</p>
            
            <?php   $messages = explode("\n", `ls *.msg`);
                    array_pop($messages); ?>
                    
            <p><a href="#MESSAGES">Messages:</a> <?php echo count($messages); ?></p>
        </td>
    </tr>
</table>

<!-- Summary ends here -->

<!-- Code begins here -->

<pre>

<span class="pycomment">#!/usr/bin/env python</span>

<span class="pycomment">"""
example non-animated entry for the pygame text contest

if you would like to change this for your own entry, modify
the first function that renders the text. you'll also probably
want to change the arguments that your function used. simply
running the script should show some sort of example for your
text rendering
"""</span>
import os, sys, pygame, pygame.font, pygame.image
from pygame.locals import *


<span class="pydef">def textDropShadow(font, message, offset, fontcolor, shadowcolor):</span>
    base = font.render(message, 0, fontcolor)
    size = base.get_width() + offset, base.get_height() + offset
    img = pygame.Surface(size, 16)
    base.set_palette_at(1, shadowcolor)
    img.blit(base, (offset, offset))
    base.set_palette_at(1, fontcolor)
    img.blit(base, (0, 0))
    return img




entry_info = '<span class="pystring">Drop Shadow, by Pete Shinners</span>'

<span class="pycomment">#this code will display our work, if the script is run...</span>
if __name__ == '<span class="pystring">__main__</span>':
    pygame.init()

    <span class="pycomment">#create our fancy text</span>
    white = 255, 255, 255
    grey = 100, 100, 100
    bigfont = pygame.font.Font(None, 60)
    text = textDropShadow(bigfont, entry_info, 3, white, grey)

    <span class="pycomment">#create a window the correct size</span>
    win = pygame.display.set_mode(text.get_size())
    winrect = win.get_rect()
    win.blit(text, (0, 0))
    pygame.display.flip()
    
    <span class="pycomment">#wait for the finish</span>
    while 1:
        event = pygame.event.wait()
        if event.type is KEYDOWN and event.key == K_s: #save it
            name = os.path.splitext(sys.argv[0])[0] + '<span class="pystring">.bmp</span>'
            print '<span class="pystring">Saving image to:</span>', name
            pygame.image.save(win, name)
        elif event.type in (QUIT,KEYDOWN,MOUSEBUTTONDOWN):
            break


</pre>

<!-- Code ends here -->

<!-- Messages begin here -->

<?php include "../global/messages.php"; ?>

<?php include "../global/footer.html"; ?>

