<?php include "../global/header.html"; ?>
    
<!-- Summary begins here -->

<table bgcolor="#FFFFFF" width="80%" align="center" cellpadding="20">
    <tr>
        <td>
            <H3>Title:  Inputbox Module</H3>
            <p>Author: Timothy Downs<br>
            Submission date: January 23, 2002</p>
	  
            <p>Description: A function to display an inputbox and return the inputted text string.</p>
            
            <p align="center"><img src="inputbox.png" width="320" height="240"></p>

            <p>Download: <a href="inputbox.py">inputbox.py</a></p>	  

            <p>pygame version required: Any<br>
            SDL version required: Any<br>
            Python version required: Any</p>

            <p>Comments: While pygame still lacks a formal gui module, a variety of informal toolkit components are starting to appear.  This inputbox module presents a simple text box and blocks until a lowercase text string is entered.  The prompt (&quot;Name&quot; in the picture above) is supplied when the ask function is called, and the user is able to use the backspace key to edit their input.</p>
            
            <?php   $messages = explode("\n", `ls *.msg`);
                    array_pop($messages); ?>
                    
            <p><a href="#MESSAGES">Messages:</a> <?php echo count($messages); ?></p>
        </td>
    </tr>
</table>

<!-- Summary ends here -->

<!-- Code begins here -->

<pre>

<span class="pycomment"># by Timothy Downs, inputbox written for my map editor

# This program needs a little cleaning up
# It ignores the shift key
# And, for reasons of my own, this program converts "-" to "_"

# A program to get user input, allowing backspace etc
# shown in a box in the middle of the screen
# Called by:
# import inputbox
# answer = inputbox.ask(screen, "Your name")
#
# Only near the center of the screen is blitted to</span>

import pygame, pygame.font, pygame.event, pygame.draw, string
from pygame.locals import *

<span class="pydef">def get_key():</span>
  while 1:
    event = pygame.event.poll()
    if event.type == KEYDOWN:
      return event.key
    else:
      pass

<span class="pydef">def display_box(screen, message):</span>
  <span class="pycomment">"Print a message in a box in the middle of the screen"</span>
  fontobject = pygame.font.Font(None,18)
  pygame.draw.rect(screen, (0,0,0),
                   ((screen.get_width() / 2) - 100,
                    (screen.get_height() / 2) - 10,
                    200,20), 0)
  pygame.draw.rect(screen, (255,255,255),
                   ((screen.get_width() / 2) - 102,
                    (screen.get_height() / 2) - 12,
                    204,24), 1)
  if len(message) != 0:
    screen.blit(fontobject.render(message, 1, (255,255,255)),
                ((screen.get_width() / 2) - 100, (screen.get_height() / 2) - 10))
  pygame.display.flip()

<span class="pydef">def ask(screen, question):</span>
  <span class="pycomment">"ask(screen, question) -> answer"</span>
  pygame.font.init()
  current_string = []
  display_box(screen, question + "<span class="pystring">: </span>" + string.join(current_string,""))
  while 1:
    inkey = get_key()
    if inkey == K_BACKSPACE:
      current_string = current_string[0:-1]
    elif inkey == K_RETURN:
      break
    elif inkey == K_MINUS:
      current_string.append(&quot;<span class="pystring">_</span>&quot;)
    elif inkey <= 127:
      current_string.append(chr(inkey))
    display_box(screen, question + "<span class="pystring">: </span>" + string.join(current_string,""))
  return string.join(current_string,"")

<span class="pydef">def main():</span>
  screen = pygame.display.set_mode((320,240))
  print ask(screen, "<span class="pystring">Name</span>") + "<span class="pystring"> was entered</span>"

if __name__ == '<span class="pystring">__main__</span>': main()

</pre>

<!-- Code ends here -->

<!-- Messages begin here -->

<?php include "../global/messages.php"; ?>

<?php include "../global/footer.html"; ?>

