<?php include "../global/header.html"; ?>
    
<!-- Summary begins here -->

<table bgcolor="#FFFFFF" width="80%" align="center" cellpadding="20">
    <tr>
        <td>
            <H3>Title: Palette-loading utility function </H3>
            <p>Author: Kevin Turner (acapnotic at users.sourceforge.net)<br>
            Submission date: May 29, 2001</p>
	  
            <p>Description: Loads a palette file and returns a list suitable for Surface.setpalette()</p>

            <p>Download: <a href="loadpal.py">loadpal.py</a></p>	  

            <p>pygame version required: Any<br>
            SDL version required: Any<br>
            Python version required: Any</p>

            <p>Comments: If you've ever tried to specify a surface's entire palette using surface.set_palette(), you may have noticed how frustrating it is to create 256 individual RGB tuples.  Kevin's code allows you to load a gimp or Fractint palette file by calling load_palette(filename), or you can specify your own palette file in the format indicated in the docstrings.</p>
            
            <?php   $messages = explode("\n", `ls *.msg`);
                    array_pop($messages); ?>
                    
            <p><a href="#MESSAGES">Messages:</a> <?php echo count($messages); ?></p>
        </td>
    </tr>
</table>

<!-- Summary ends here -->

<!-- Code begins here -->

<pre>

<span class="pycomment"># Palette-loading utility function, by Kevin.
# Public domain.  Have fun.</span>

import re

<span class="pydef">def load_palette(name='Firecode'):</span>
    <span class="pycomment">"""Loads a palette file and returns a list suitable for Surface.setpalette()

    Loads a palette file, which is anything that looks like this:

    0 0 0
    0 0  4
    0 64 8
    ...

    GIMP and Fractint palette files both match this description.
    Lines that don't match are silently ignored.
    Only recognizes decimal values, not 0xFF or #AA66FF.
    """</span>

    f = open(name)
    pal = []
    rgb_re = re.compile('^(?:\s+)?(\d+)\s+(\d+)\s+(\d+)')
    for l in f.readlines():
        m = rgb_re.search(l)
        if m:
            pal.append(tuple(map(int,m.groups())))

    if len(pal) != 256:
        print "<span class="pystring">Warning: palette \</span>'%s\'<span class="pystring"> does not contain 256 entries.</span>" % name
    if pal[0] != (0,0,0):
        print "<span class="pystring">Warning: palette \</span>'%s\'<span class="pystring"> has entry 0 set to non-black color</span>"\
              % name, pal[0]
    return pal

</pre>

<!-- Code ends here -->

<!-- Messages begin here -->

<?php include "../global/messages.php"; ?>

<?php include "../global/footer.html"; ?>

