<?php include "../global/header.html"; ?>
    
<!-- Summary begins here -->

<table bgcolor="#FFFFFF" width="80%" align="center" cellpadding="20">
    <tr>
        <td>
            <H3>Title:  Sinkblur</H3>
            <p>Author: Brendan Becker<br>
            Submission date: January 05, 2002</p>
	  
            <p>Description: Renders the text with a static 'motion blur' effect, as if the text is receeding.</p>
            
            <p align="center"><img src="sinkblur.png" width="460" height="70"></p>

            <p>Download: <a href="sinkblur.py">sinkblur.py</a></p>	  

            <p>pygame version required: Any<br>
            SDL version required: Any<br>
            Python version required: Any</p>

            <p>Comments: Import this module as mentioned in the script comments, then create your own text surfaces with the sinkblur() function.  The module has an example script - hit 's' to take a screenshot.  A nice effect - a neat improvement would be to allow effect_amt to be assigned negative values, to create an 'approaching text' effect.</p>
            
            <?php   $messages = explode("\n", `ls *.msg`);
                    array_pop($messages); ?>
                    
            <p><a href="#MESSAGES">Messages:</a> <?php echo count($messages); ?></p>
        </td>
    </tr>
</table>

<!-- Summary ends here -->

<!-- Code begins here -->

<pre>

<span class="pycomment"># Sinkblur, by Brendan Becker  ( http://clickass.org/ )
# use this anywhere you want, just give me a little credit =]
#
# Implement with:
# import sinkblur
# [....]
#  asdf = sinkblur.sinkblur("text",size,effect_amt,(rectsizex,rectsizey),(r,g,b))
#  asdfpos = asdf.get_rect()
#  asdfpos.centerx = screen.get_rect().centerx
#  asdfpos.top = 16
#  screen.blit(asdf,asdfpos)</span>

import pygame, pygame.font, os, sys, pygame.image
from pygame.locals import *

<span class="pycomment"># SINKBLUR - sinking "motion blur" effect (middle is brightest)</span>
<span class="pydef">def sinkblur(textstring, textsize, sinkamount, displaysize, trgb=(255,255,255)):</span>
    displaysurface = pygame.Surface(displaysize)
    displayrect = displaysurface.get_rect()
    if sinkamount*2 > textsize:
        sinkamount = textsize / 2
    for it in range(sinkamount):
        font = pygame.font.Font(None, textsize-(it*2))
        camt = sinkamount-it
        text = font.render(textstring, 1, (trgb[0]/camt,trgb[1]/camt,trgb[2]/camt) )
        textrect = text.get_rect()
        dx = displayrect.centerx - textrect.centerx
        dy = displayrect.centery - textrect.centery
        displaysurface.blit(text, (dx,dy) )
    return displaysurface

entry_info = '<span class="pystring">Sinkblur, by Brendan Becker</span>'

<span class="pycomment">#this code will display our work, if the script is run...</span>
if __name__ == '<span class="pystring">__main__</span>':
    pygame.init()

    <span class="pycomment">#create our fancy text</span>
    text = sinkblur(entry_info, 55, 8, (460,70), (200, 200, 255))

    <span class="pycomment">#create a window the correct size</span>
    win = pygame.display.set_mode(text.get_size())
    winrect = win.get_rect()
    win.blit(text, (0, 0))
    pygame.display.flip()
    
    <span class="pycomment">#wait for the finish</span>
    while 1:
        event = pygame.event.wait()
        if event.type is KEYDOWN and event.key == K_s: <span class="pycomment">#save it</span>
            name = os.path.splitext(sys.argv[0])[0] + '<span class="pystring">.bmp</span>'
            print '<span class="pystring">Saving image to:</span>', name
            pygame.image.save(win, name)
        elif event.type in (QUIT,KEYDOWN,MOUSEBUTTONDOWN):
            break

</pre>

<!-- Code ends here -->

<!-- Messages begin here -->

<?php include "../global/messages.php"; ?>

<?php include "../global/footer.html"; ?>

