<?php include "../global/header.html"; ?>
    
<!-- Summary begins here -->

<table bgcolor="#FFFFFF" width="80%" align="center" cellpadding="20">
    <tr>
        <td>
            <H3>Title:  'Unlimited Sprites' Effect</H3>
            <p>Author: Gareth Noyce (http://www.korruptor.demon.co.uk)<br>
            Submission date: Aug 29, 2002</p>
	  
            <p>Description: A port of the famous 'Unlimited Bobs' demo effect.</p>
            <p align="center"><img src="sprites1.png" width="480" height="400"></p>
            <p align="center"><img src="sprites2.png" width="480" height="400"></p>

            <p>Download: <a href="unlimited-sprites.zip">unlimited-sprites.zip</a></p>	  

            <p>pygame version required: Any<br>
            SDL version required: Any<br>
            Python version required: 2.0 or newer</p>

            <p>Comments: The impressive &quot;Infinite Bobs&quot; visual effect is the latest demo effect to be ported to pygame by Gareth Noyce.  Let this one run for a few minutes - you'll be amazed at the amount of motion achieved with a few lines of code. This submission achieves its eye-catching effect without the aid of Numeric and Surfarray.</p>
            <?php   $messages = explode("\n", `ls *.msg`);
                    array_pop($messages); ?>
                    
            <p><a href="#MESSAGES">Messages:</a> <?php echo count($messages); ?></p>
        </td>
    </tr>
</table>

<!-- Summary ends here -->

<!-- Code begins here -->

<pre>

<span class="pycomment">"""
Name	:	unlimited 'bobs' - korruptor, http://www.korruptor.demon.co.uk
Desc	:

I first saw this in the Dragons MegaDemo on the A500 back in '89 and it blew me away. 
How gutted I was when Wayne "tripix" Keenan told me how easy it was and knocked up an 
an example demo a couple of years later.

For those of you that didn't know how it was done, here's a pygame example. It's 
basically a flick-book effect; you draw the same sprite in different positions on 
25 different 'screens' and flick between them. When you've drawn on all 25 you loop 
back to the beginning and keep on blitting. 

Sprite offsets make it look like you're adding sprites. Simple.
"""</span>

import pygame, pygame.image
from pygame.surfarray import *
from pygame.locals import *
from math import *


<span class="pycomment"># ------------------------------------------------------------------------------------</span>

RES 		= (480,400)
PI 		= 3.14159
DEG2RAD 	= PI/180
SURFS           = []

<span class="pycomment"># ------------------------------------------------------------------------------------</span>
<span class="pydef">def main():</span>
     
    	<span class="pycomment"># Initialise pygame, and grab an 8bit display.</span>
    	pygame.init()
    	screen		= pygame.display.set_mode(RES,0, 8)
        bob		= pygame.image.load("<span class="pystring">bob.gif</span>")
        
        <span class="pycomment"># load a sprite and set the palette</span>
        bob.set_colorkey((255,255,255))
        screen.set_palette(bob.get_palette())
            

        <span class="pycomment"># Create 25 blank surfaces to draw on.</span>
        for i in range(0,25):
            SURFS.append(pygame.Surface(RES,0,8))
            SURFS[i].set_palette(bob.get_palette())

        xang    = 0.0
        yang    = 0.0
        surf    = 0
        
        <span class="pycomment"># Fruity loops...</span>
        while 1:
    
            <span class="pycomment"># Have we received an event to quit the program?</span>
            for e in pygame.event.get():
                if e.type in (QUIT,KEYDOWN,MOUSEBUTTONDOWN):
                    return


            <span class="pycomment"># Get some x/y positions</span>
            x = (RES[0]/2)*sin((xang*DEG2RAD)*0.75)
            y = (RES[1]/2)*cos((yang*DEG2RAD)*0.67)
  
            <span class="pycomment"># Inc the angle of the sine</span>
            xang += 1.17
            yang += 1.39
        
            <span class="pycomment"># blit our 'bob' on the 'active' surface</span>
            SURFS[surf].blit(bob,(x+(RES[0]/2)-32,y+(RES[1]/2)-32))
            
            <span class="pycomment"># blit the active surface to the screen</span>
            screen.blit(SURFS[surf],(0,0))

            <span class="pycomment"># display the results</span>
            pygame.display.flip()

            <span class="pycomment"># inc the active surface number</span>
            surf = (surf+1) % 25
            
        <span class="pycomment"># Bye!</span>
        return

<span class="pycomment"># ------------------------------------------------------------------------------------</span>
if __name__ == '<span class="pystring">__main__</span>': main()
<span class="pycomment"># End of sauce. Pass the chips...</span>


</pre>

<!-- Code ends here -->

<!-- Messages begin here -->

<?php include "../global/messages.php"; ?>

<?php include "../global/footer.html"; ?>

