<?php include "../global/header.html"; ?>
    
<!-- Summary begins here -->

<table bgcolor="#FFFFFF" width="80%" align="center" cellpadding="20">
    <tr>
        <td>
            <H3>Title:  Wavey Text</H3>
            <p>Author: Pete Shinners (pete at shinners.org)<br>
            Submission date: December 03, 2001</p>
	  
            <p>Description: Animated effect that deforms a text string along a sine wave.</p>
            
            <p align="center"><img src="wavey.gif" width="528" height="72"></p>

            <p>Download: <a href="wavey.py">wavey.py</a></p>	  

            <p>pygame version required: Any<br>
            SDL version required: Any<br>
            Python version required: Any</p>

            <p>Comments: The code is quite clear; the example program continues animating the text until you click on the window - pressing 's' takes a screenshot.</p>
            
            <?php   $messages = explode("\n", `ls *.msg`);
                    array_pop($messages); ?>
                    
            <p><a href="#MESSAGES">Messages:</a> <?php echo count($messages); ?></p>
        </td>
    </tr>
</table>

<!-- Summary ends here -->

<!-- Code begins here -->

<pre>

<span class="pycomment">#!/usr/bin/env python

"""
example animated entry for the pygame text contest

if you would like to change this for your own entry, modify
the class so it returns the next image of the rendered text
each call to animate(). Note the image size should not change
for this simple framework.
"""</span>
import os, sys, math, pygame, pygame.font, pygame.image
from pygame.locals import *


<span class="pydef">class textWavey:</span>
    <span class="pydef">def __init__(self, font, message, fontcolor, amount=10):</span>
        self.base = font.render(message, 0, fontcolor)
        self.steps = range(0, self.base.get_width(), 2)
        self.amount = amount
        self.size = self.base.get_rect().inflate(0, amount).size
        self.offset = 0.0
        
    <span class="pydef">def animate(self):</span>
        s = pygame.Surface(self.size)
        height = self.size[1]
        self.offset += 0.5
        for step in self.steps:
            src = Rect(step, 0, 2, height)
            dst = src.move(0, math.cos(self.offset + step*.02)*self.amount)
            s.blit(self.base, dst, src)
        return s





entry_info = '<span class="pystring">Wavey, by Pete Shinners</span>'

<span class="pycomment">#this code will display our work, if the script is run...</span>
if __name__ == '<span class="pystring">__main__</span>':
    pygame.init()

    <span class="pycomment">#create our fancy text renderer</span>
    bigfont = pygame.font.Font(None, 60)
    white = 255, 255, 255
    renderer = textWavey(bigfont, entry_info, white, 16)
    text = renderer.animate()

    <span class="pycomment">#create a window the correct size</span>
    win = pygame.display.set_mode(text.get_size())
    win.blit(text, (0, 0))
    pygame.display.flip()
    
    <span class="pycomment">#wait for the finish</span>
    finished = 0
    while not finished:
        pygame.time.delay(40)
        for event in pygame.event.get():
            if event.type is KEYDOWN and event.key == K_s: <span class="pycomment">#save it</span>
                name = os.path.splitext(sys.argv[0])[0] + '<span class="pystring">.bmp</span>'
                print '<span class="pystring">Saving image to:</span>', name
                pygame.image.save(win, name)
            elif event.type in (QUIT,KEYDOWN,MOUSEBUTTONDOWN):
                finished = 1
        
        text = renderer.animate()
        win.blit(text, (0, 0))
        pygame.display.flip()

</pre>

<!-- Code ends here -->

<!-- Messages begin here -->

<?php include "../global/messages.php"; ?>

<?php include "../global/footer.html"; ?>

